summaryrefslogtreecommitdiff
path: root/gold/testsuite/pr26936.sh
diff options
context:
space:
mode:
authorH.J. Lu <hjl.tools@gmail.com>2020-11-29 05:55:23 -0800
committerH.J. Lu <hjl.tools@gmail.com>2020-11-29 05:55:35 -0800
commit8ca751ee637ce1b8d1b284a794ffdb327951d0f8 (patch)
treead55a7b80f214c2b63cf2059f5740eb94e9902e1 /gold/testsuite/pr26936.sh
parentb214250c1e058b251ec90f024795965ad1f9e91d (diff)
downloadbinutils-gdb-8ca751ee637ce1b8d1b284a794ffdb327951d0f8.tar.gz
gold: Get linkonce/comdate sections for debugging sections
When relocating debug sections, get the section index for the linkonce section. Since symbols referenced in debugging sections can be defined a single comdat section with a different section name, also check the single comdat section. PR gold/26937 * object.cc (Sized_relobj_file::map_to_kept_section): Get the section index for linkonce section. Also check the single comdat section. * testsuite/Makefile.am (check_SCRIPTS): Add pr26936.sh. (check_DATA): Add pr26936a.stdout and pr26936b.stdout. (MOSTLYCLEANFILES): Add pr26936a and pr26936b. (pr26936a.stdout): New target. (pr26936a): Likewise. (pr26936b.stdout): Likewise. (pr26936b): Likewise. (pr26936a.o): Likewise. (pr26936b.o): Likewise. (pr26936c.o): Likewise. (pr26936d.o): Likewise. * testsuite/Makefile.in: Regenerated. * testsuite/pr26936.sh: New file. * testsuite/pr26936a.s: Likewise. * testsuite/pr26936b.s: Likewise. * testsuite/pr26936c.s: Likewise. * testsuite/pr26936d.s: Likewise.
Diffstat (limited to 'gold/testsuite/pr26936.sh')
-rwxr-xr-xgold/testsuite/pr26936.sh55
1 files changed, 55 insertions, 0 deletions
diff --git a/gold/testsuite/pr26936.sh b/gold/testsuite/pr26936.sh
new file mode 100755
index 00000000000..364f50f1a9b
--- /dev/null
+++ b/gold/testsuite/pr26936.sh
@@ -0,0 +1,55 @@
+#!/bin/sh
+
+# pr26936.sh -- Tests for relocations in debug sections against linkonce
+# and comdat sections.
+
+# Copyright (C) 2020 Free Software Foundation, Inc.
+
+# This file is part of gold.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston,
+# MA 02110-1301, USA.
+
+set -e
+
+check()
+{
+ number_of_occurrence=`egrep "$2" ./$1 -o| wc -l`
+ if [ $number_of_occurrence != $3 ]
+ then
+ echo "$1: \"$2\" $3: Failed"
+ status=1
+ fi
+}
+
+status=0
+check pr26936a.stdout "^pr26936a.s +6 +0x10108 +x" 1
+check pr26936a.stdout "^pr26936b.s +5 +0x10109 +x" 1
+check pr26936a.stdout "^pr26936b.s +11 +0x10108 +x" 1
+check pr26936a.stdout "^pr26936c.s +6 +0x10108 +x" 1
+check pr26936a.stdout "^ +0+10108 0+1" 3
+check pr26936a.stdout "^ +0+10109 0+1" 1
+check pr26936a.stdout "^ +0+ 0+10109 0+1010a" 1
+check pr26936a.stdout "^ +0+ 0+10108 0+10109" 1
+check pr26936b.stdout "^pr26936d.s +6 +0x10108 +x" 1
+check pr26936b.stdout "^pr26936b.s +5 +0x10109 +x" 1
+check pr26936b.stdout "^pr26936b.s +11 +0x10108 +x" 1
+check pr26936b.stdout "^pr26936c.s +6 +0x10108 +x" 1
+check pr26936b.stdout "^ +0+10108 0+1" 3
+check pr26936b.stdout "^ +0+10109 0+1" 1
+check pr26936b.stdout "^ +0+ 0+10109 0+1010a" 1
+check pr26936b.stdout "^ +0+ 0+10108 0+10109" 1
+
+exit $status